var Loggly = require('winston-loggly').Loggly
var winston = require('winston');
module.exports = function (config) {
  var handleExceptions = true;
  if (config.get('test')) {
    handleExceptions = false
  }
  var transports = [
    new winston.transports.Console({
      handleExceptions: handleExceptions,
      colorize: true,
      prettyPrint: true,
      level: 'verbose'
    })
  ]
  var loggly = config.get('loggly')
  if (loggly) {
    transports.push(new winston.transports.Loggly({
      subdomain: 'nisaacson',
      inputToken: loggly.inputToken,
      handleExceptions: true,
      level: 'info',
      json: true
    }))
  }
  var logger = new winston.Logger({
    transports: transports,
    exitOnError: true
  });
  return logger
}
