var fs = require('fs')
var should = require('should');
var inspect = require('eyespect').inspector()
var optimist = require('optimist');
var nconf = require('nconf')
module.exports = function (data, cb) {
  var rebuild = data.rebuild || require('./rebuild')
  var start = data.start || require('./start')
  getConfig(data, function (err, config) {
    if (err) { return cb(err); }
    if (data.role) {
      config.defaults({
        role: data.role
      })
    }

    rebuild(function (err, reply) {
      if (err) { return cb(err) }
      data.config = config
      start(data, cb)
    })
  })
}

function getConfig(data, cb) {
  if (data.config) {
    return cb(null, data.config)
  }
  var argv = optimist.demand(['config']).argv;
  var configFilePath = argv.config
  fs.exists(configFilePath, function (exists) {
    if (!exists) {
      return cb({
        message: 'failed to spinup server',
        error: 'config file not found at path: ' + configFilePath,
        stack: new Error().stack
      })
    }
    var config = nconf.argv().env().file({file: argv.config});
    cb(null, config)
  })
}
