var inspect = require('eyespect').inspector({maxLength: 909999898})
var passport = require('passport')
var http = require('http')
var authLib = require('api-auth')
var middleware = require('api-middleware')
var express = require('express')
var seaport = require('seaport')
var rk = require('required-keys');
module.exports = function (data, cb) {
  var keys = ['config', 'logger', 'db', 'role','parse']
  var err = rk.truthySync(data, keys)
  if (err) {
    return cb({
      message: 'error starting server, missing key',
      error: err,
      stack: new Error().stack
    })
  }
  var parse = data.parse
  var config = data.config
  var logger = data.logger
  var db = data.db
  var app = express()
  var role = data.role

  var seaConfig = config.get('seaport')
  var ports = seaport.connect(seaConfig.port, seaConfig.host)
  var portRange = config.get('application:portRange')
  var opts = {}
  if (portRange) {
    opts.range = portRange
  }
  var port = ports.register(role, opts)
  var middlewareData = {
    config: config,
    db: db,
    logger: logger,
    role: role,
    app: app
  }
  middleware(middlewareData)
  var authData = {
    config: data.config,
    db: data.db,
    passport: passport
  }
  authLib(authData)

  var authWare = passport.authenticate('basic', {session:false});
  app.get('/api/' + role + '/ping', function (req, res) {
    res.send('PONG')
  })
  var routes = data.routes
  if (routes) {
    var routesData = {
      config: config,
      db: db,
      app: app,
      role: role,
      passport: passport,
      authWare: authWare
    }
    routes(routesData)
  }
  else {
    var parseURL = '/api/' + role + '/parse/:id';
    app.post(parseURL, authWare, parse)
  }
  var server = http.createServer(app)
  server.listen(port, function () {
    var output = {
      server: server,
      port: port,
      logger: logger,
      config: config,
      db: db
    }
    cb(null, output)
  })

}
