var rk = require('required-keys');
var should = require('should')
var inspect = require('eyespect').inspector()
var assert = require('assert');
var fs = require('fs');
var path = require('path');
var optimist = require('optimist');
var nconf = require('nconf')
var loggerLib = require('./lib/logger')
var dbLib = require('./lib/db')
var serverLib = require('./server')
module.exports = function start(data, cb) {
  inspect('start called')
  var keys = ['config', 'parse']
  var err = rk.truthySync(data, keys)
  if (err) {
    return cb({
      message: 'error starting up parse server, missing key',
      error: err,
      stack: new Error().stack
    })
  }
  var config = data.config
  var role = config.get('role')
  if (!role) {
    return cb({
      message: 'error starting up parse server, missing key',
      error: 'role must be set in your config json file or as a comand line option',
      stack: new Error().stack
    })
  }
  var logger = loggerLib(config)
  data.logger = logger
  data.role = role
  dbLib(config, function (err, db) {
    if (err) { return cb(err); }
    data.db = db
    logger.debug('starting server', {
      role: role,
      service: 'docparse'
    })
    serverLib(data, function (err, reply) {
      if (err) { return cb(err); }
      logger.debug('server online', {
        role: role,
        service: 'docparse',
        port: reply.port
      })
      cb(null, reply)
    })
  })
}
